﻿using System;
using System.IO;
using System.IO.Ports;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using NTL.KinectLib;

namespace VitalMonitor
{
    public partial class Form1 : Form
    {
        private ADconverter ADC = new ADconverter(); //【A/Dコンバータ関連】

        //*************************************************************
        //***【Form初期化処理】
        //*************************************************************
        public Form1()
        {
            InitializeComponent();

            FormClosing += Form1_FormClosing;          //【シリアルポート終了処理イベントの設定】
            checkBox1.Checked = ADC.Chk[0];
            checkBox2.Checked = ADC.Chk[1];
            checkBox3.Checked = ADC.Chk[2];
            checkBox4.Checked = ADC.Chk[3];
            switch (ADC.Zoom[0])
            {
                case 0: radioButton1.Checked = true; break;
                case 1: radioButton2.Checked = true; break;
                case 2: radioButton3.Checked = true; break;
                case 3: radioButton4.Checked = true; break;
                case 4: radioButton5.Checked = true; break;
                case 5: radioButton6.Checked = true; break;
                case 6: radioButton7.Checked = true; break;
            }
            switch (ADC.Zoom[1])
            {
                case 0: radioButton8.Checked = true; break;
                case 1: radioButton9.Checked = true; break;
                case 2: radioButton10.Checked = true; break;
                case 3: radioButton11.Checked = true; break;
                case 4: radioButton12.Checked = true; break;
                case 5: radioButton13.Checked = true; break;
                case 6: radioButton14.Checked = true; break;
            }
            switch (ADC.Zoom[2])
            {
                case 0: radioButton15.Checked = true; break;
                case 1: radioButton16.Checked = true; break;
                case 2: radioButton17.Checked = true; break;
                case 3: radioButton18.Checked = true; break;
                case 4: radioButton19.Checked = true; break;
                case 5: radioButton20.Checked = true; break;
                case 6: radioButton21.Checked = true; break;
            }
            switch (ADC.Zoom[3])
            {
                case 0: radioButton22.Checked = true; break;
                case 1: radioButton23.Checked = true; break;
                case 2: radioButton24.Checked = true; break;
                case 3: radioButton25.Checked = true; break;
                case 4: radioButton26.Checked = true; break;
                case 5: radioButton27.Checked = true; break;
                case 6: radioButton28.Checked = true; break;
            }

            radioButton1.CheckedChanged += CH0_Zoom;
            radioButton2.CheckedChanged += CH0_Zoom;
            radioButton3.CheckedChanged += CH0_Zoom;
            radioButton4.CheckedChanged += CH0_Zoom;
            radioButton5.CheckedChanged += CH0_Zoom;
            radioButton6.CheckedChanged += CH0_Zoom;
            radioButton7.CheckedChanged += CH0_Zoom;
            radioButton8.CheckedChanged += CH1_Zoom;
            radioButton9.CheckedChanged += CH1_Zoom;
            radioButton10.CheckedChanged += CH1_Zoom;
            radioButton11.CheckedChanged += CH1_Zoom;
            radioButton12.CheckedChanged += CH1_Zoom;
            radioButton13.CheckedChanged += CH1_Zoom;
            radioButton14.CheckedChanged += CH1_Zoom;
            radioButton15.CheckedChanged += CH2_Zoom;
            radioButton16.CheckedChanged += CH2_Zoom;
            radioButton17.CheckedChanged += CH2_Zoom;
            radioButton18.CheckedChanged += CH2_Zoom;
            radioButton19.CheckedChanged += CH2_Zoom;
            radioButton20.CheckedChanged += CH2_Zoom;
            radioButton21.CheckedChanged += CH2_Zoom;
            radioButton22.CheckedChanged += CH3_Zoom;
            radioButton23.CheckedChanged += CH3_Zoom;
            radioButton24.CheckedChanged += CH3_Zoom;
            radioButton25.CheckedChanged += CH3_Zoom;
            radioButton26.CheckedChanged += CH3_Zoom;
            radioButton27.CheckedChanged += CH3_Zoom;
            radioButton28.CheckedChanged += CH3_Zoom;
            button2.Text = "Bluetooth接続";
        }

        //*************************************************************
        //***【Form終了時処理】
        //*************************************************************
        void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            ADC.TerminateSerialPort(); //【シリアルポートを閉じる】
        }

        //*************************************************************
        //***【Bluetooth通信接続処理】
        //*************************************************************
        private void button2_Click(object sender, EventArgs e)
        {
            if (button2.Text == "Bluetooth切断") 
            {
                button2.Enabled = false;        //
                ADC.TerminateSerialPort();      //【シリアルポートを閉じる】
                button2.Text = "Bluetooth接続"; //
                button2.Enabled = true;         //
                return;
            }
            button2.Enabled = false;
            button2.Text = "Bluetoothスキャン中";
            if (ADC.Initialize() == false)
            {
                if (ADC.PortName.Length == 0)
                {
                    MessageBox.Show("接続可能なシリアル通信ポートが見当たりません。", "Vital Moniotor", MessageBoxButtons.OK);
                }
                else
                {
                    MessageBox.Show("シリアル通信ポートが応答しませんでした。", "Vital Moniotor", MessageBoxButtons.OK);
                }
                button2.Text = "Bluetooth接続";
                button2.Enabled = true;
                return;
            }
            //【初期化処理】
            this.Text += "  Bluetooth Comport:" + ADC.COMPORT;

            //【表示関係】
            pictureBox1.Image = ADC.Disp[0].Bmp;
            pictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;
            button2.Text = "Bluetooth切断";
            button2.Enabled = true;

            //【タイマーイベント】timer1:波形表示
            timer1.Interval = 200;
            timer1.Enabled = true;
            timer1.Tick += timer1_Tick;
        }

        //*************************************************************
        //***【タイマーイベント】200ミリ秒ごと
        //*************************************************************
        void timer1_Tick(object sender, EventArgs e)
        {
            this.label1.Text = "Time: " + ADC.HBR.Time.ToString() + "[秒]" + "読込待ちバイト数：" + ADC.ReceivedBytes.ToString();
            this.label2.Text = "心拍数：" +ADC.HBR.HeartBeatRate.ToString("F2")+"[拍/分]";

            Graphics g1 = Graphics.FromImage(pictureBox1.Image);
            ADC.DrawWaves(g1);
            g1.Dispose();
            pictureBox1.Image = ADC.Disp[0].Bmp;
            Validate();   //【更新を反映する】
            if (ADC.Flag)
            {
                button1.Enabled = false;
            }
            else
            { 
                button1.Enabled = true;
                if (ADC.Sensor.IsOpen == false)
                {
                    button2.Text = "Bluetooth接続"; //
                    button2.Enabled = true;         //
                }
            }
        }

        //*************************************************************
        //***【測定開始】
        //*************************************************************
        private void button1_Click(object sender, EventArgs e)
        {
            ADC.StartSampling(int.Parse(textBox1.Text)); //【秒数単位の測定時間を指定して測定開始】
        }

        //*************************************************************
        //***【波形表示許可変更】チェックボックス
        //*************************************************************
        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked) { ADC.Chk[0] = true; } else { ADC.Chk[0] = false; }
        }
        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox2.Checked) { ADC.Chk[1] = true; } else { ADC.Chk[1] = false; }
        }
        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox3.Checked) { ADC.Chk[2] = true; } else { ADC.Chk[2] = false; }
        }
        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox4.Checked) { ADC.Chk[3] = true; } else { ADC.Chk[3] = false; }
        }

        //*************************************************************
        //***【波形表示倍率変更】ラジオボタンで表示倍率を変更。実際の倍率はADconverterクラス内の配列で定義
        //*************************************************************
        void CH0_Zoom(object sender, EventArgs e)
        {
            if (radioButton1.Checked) { ADC.Zoom[0] = 0; }
            if (radioButton2.Checked) { ADC.Zoom[0] = 1; }
            if (radioButton3.Checked) { ADC.Zoom[0] = 2; }
            if (radioButton4.Checked) { ADC.Zoom[0] = 3; }
            if (radioButton5.Checked) { ADC.Zoom[0] = 4; }
            if (radioButton6.Checked) { ADC.Zoom[0] = 5; }
            if (radioButton7.Checked) { ADC.Zoom[0] = 6; }
        }
        void CH1_Zoom(object sender, EventArgs e)
        {
            if (radioButton8.Checked) { ADC.Zoom[1] = 0; }
            if (radioButton9.Checked) { ADC.Zoom[1] = 1; }
            if (radioButton10.Checked) { ADC.Zoom[1] = 2; }
            if (radioButton11.Checked) { ADC.Zoom[1] = 3; }
            if (radioButton12.Checked) { ADC.Zoom[1] = 4; }
            if (radioButton13.Checked) { ADC.Zoom[1] = 5; }
            if (radioButton14.Checked) { ADC.Zoom[1] = 6; }
        }
        void CH2_Zoom(object sender, EventArgs e)
        {
            if (radioButton15.Checked) { ADC.Zoom[2] = 0; }
            if (radioButton16.Checked) { ADC.Zoom[2] = 1; }
            if (radioButton17.Checked) { ADC.Zoom[2] = 2; }
            if (radioButton18.Checked) { ADC.Zoom[2] = 3; }
            if (radioButton19.Checked) { ADC.Zoom[2] = 4; }
            if (radioButton20.Checked) { ADC.Zoom[2] = 5; }
            if (radioButton21.Checked) { ADC.Zoom[2] = 6; }
        }
        void CH3_Zoom(object sender, EventArgs e)
        {
            if (radioButton22.Checked) { ADC.Zoom[3] = 0; }
            if (radioButton23.Checked) { ADC.Zoom[3] = 1; }
            if (radioButton24.Checked) { ADC.Zoom[3] = 2; }
            if (radioButton25.Checked) { ADC.Zoom[3] = 3; }
            if (radioButton26.Checked) { ADC.Zoom[3] = 4; }
            if (radioButton27.Checked) { ADC.Zoom[3] = 5; }
            if (radioButton28.Checked) { ADC.Zoom[3] = 6; }
        }
    }
}
