﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NTL.KinectLib
{
    //***************************************************************
    //【FIFOを用いた移動累積加算処理】6,250degits@800SPSを100,000degits@800SPSに変換する
    //***************************************************************
    public class MovingAverage
    {
        public int Value;      // 0 ～ 100000degits
        public double Voltage; // 0.0V～3.3V
        private const int nFIFO = 16; //【FIFO段数】16で固定(50Hz圏)
        private const double K1 = 3.3 / 100000.0; // 6250degits*16=100000degits
        private int pFIFO;
        private int[] FIFO = new int[nFIFO];

        public void Initialize()
        {
            for (int i = 0; i < FIFO.Length; i++) { FIFO[i] = 0; }
            pFIFO = 0;
            Value = 0;
            Voltage = 0.0;
        }

        public void Load(int DataIn)
        {
            Value += DataIn - FIFO[pFIFO];              //【移動累積加算を計算】
            FIFO[pFIFO] = DataIn;                       //【新規データをFIFOに保存】
            Voltage = Value * K1;                       //【電圧に変換】100000digits==>3.3V
            pFIFO++; if (pFIFO == nFIFO) { pFIFO = 0; } //【ポインタ修正】
        }
    }
}
